#ifndef __CIN_H
#define __CIN_H

#include "iome.h"

typedef struct {
  int    key;
  char * name;
} KeyMAP;

typedef struct {
  int      Size;
  KeyMAP * MAP;
} KeyCODE;

typedef struct {
  char * KEY;
  char * WORD;
} KeyToWord;

#define MAX_MATCH 4096
typedef struct {
  int         Size;
  int         Matches;
  int         SameKey;
  int         Now;
  int         NextAvail;
  int         MATCH[MAX_MATCH];
  KeyToWord * KTW;
} KeyToWordMap;

typedef int (*xcinInit)(iomeConfig *CONF,iomeRecord *RECORD,char *Method_Name,char *CIN_File);
typedef struct {
  int          Size;
  int          Nomatch;
  char         KEY[64];
  KeyCODE      KC;
  KeyToWordMap KTW;
  iomePrepare           PREPARE;
  iomeFeedKey           FEEDKEY;
  iomeMouseOverListArea LISTAREA;
  iomeMouseOverKeyArea  KEYAREA;
  iomeNeedFocus         FOCUS;
  iomeQuit              QUIT;
} INMD;


#endif


